# upldlib.pl - File uploading subroutines
# This file is part of WebRSH 1.1b (beta)
# Copyright (C) 1997,1998  Yoram Last (ylast@mindless.com)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

sub DoUpload { # Handles file upload through cgi-lib.pl

  local($upcom) = $input{'upcom'};
  unless ($upcom) {
      $output = &AcceptFile($CFileName{'upfile'},$TFileName{'upfile'},'',$input{'ow'},$input{'tm'});
  } else {
    $upcom =~ s/\s//g;
    if ($upcom eq 'CancelUpload') {
      unlink($input{'tf'}) || &WebrshDie("Can\'t delete the temporary file $input{'tf'} \: $!");
      $output = "Upload had been canceled. Temporary file had been deleted.";
    } elsif ($upcom eq 'OverwriteExistingFile') {
      $output = &AcceptFile($input{'ofn'},$input{'tf'},$input{'fn'},1,$input{'tm'});
    } elsif ($upcom eq 'SaveUploadedFileAs:') {
      $output = &AcceptFile($input{'ofn'},$input{'tf'},$input{'fn'},'',$input{'tm'});
    } else {
      &WebrshDie;
    };
  };
  if (!$done && $pcom eq 'fm') {
    require "$ProgDir/lib/fmlib.pl" ||
      &WebrshDie("Can\'t require fmlib\.pl \: $!");
  };
}

sub AcceptFile { # Moves an uploaded file stored as $TempFile to its final destination

  local($OFileName,$TempFile,$FileName,$overwrite,$textmode) = @_;
  &WebrshDie("Can\'t find the uploaded file\: $!") unless (-f $TempFile && -r _);
  if (-z $TempFile) {
    unlink($TempFile);
    return "Upload aborted\: Uploaded file was empty";
  } else {
    unless ($FileName) { 
      $FileName = &FileName($OFileName);
      $pwd = $HomeDir unless ($pwd);
      $FileName = &FullPath($pwd,$FileName) if ($FileName);
    };
    $! = 0;
    if ($FileName) {
      local($FileExists) = -e $FileName;
      unless ($FileExists && -d $FileName) {
        unless ($FileExists && !$overwrite) {
          if (&UpMove($TempFile,$FileName,$textmode)) { 
            return "The file $OFileName had been uploaded\nand saved as $FileName\n";
          } else { &UploadProblem('Bad Filename',$OFileName,$TempFile,$FileName,$overwrite,$textmode);};
        } else { &UploadProblem('File Already Exists',$OFileName,$TempFile,$FileName,$overwrite,$textmode);};
      } else { &UploadProblem("$FileName is a Directory",$OFileName,$TempFile,$FileName,$overwrite,$textmode);};
    } else { &UploadProblem('No Filename',$OFileName,$TempFile,$FileName,$overwrite,$textmode);};
  };
}

sub UpMove { # Moves a file (Optionally in text mode).

  local($oldname,$newname,$textmode) = @_;
  local($success) = 0;
  if (!$textmode && rename($oldname,$newname)) {
    $success = 1;
  } else {
    open(OF,"<$oldname") || &WebrshDie("Can\'t read the file $oldname \: $!");
    binmode OF;
    &GetUmask if ($OStype eq 'U');
    if (open(NF,">$newname")) {
      binmode NF unless ($textmode);
      local($buf,$bchar) = ('','');
      while (read(OF,$buf,$BufSize)) {
        if ($textmode) {
          $buf =~ s/^\n// if ($bchar eq "\r");
          $bchar = substr($buf,-1,1);
          $buf =~ s/\r\n/\n/g;
          $buf =~ s/\r/\n/g;
        };
        print NF $buf || &WebrshDie("Can\'t write to the file $newname \: $!");
      };
      close OF;
      unlink($oldname);
      close NF;
      $success = 1;
    };
  };
  return $success;
}

sub UploadProblem { # Prompts for corrective action in case AcceptFile runs into problems.

  local($problem,$OFileName,$TempFile,$FileName,$overwrite,$textmode) = @_;
  print "Content-type: text/html\n\n";
  print '<HTML><HEAD><TITLE> WebRSH - Upload Problem </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'>',"\n",
  '<H2> WebRSH: Upload Problem: ',"$problem\: $!",' </H2>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  print '<H4> Please choose one of the following: </H4><CENTER>',"\n";
  print '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden NAME="id" VALUE="',"$id",'">',"\n",
  '<INPUT TYPE=hidden NAME="pwd" VALUE="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden NAME="com" VALUE="',"$com",'">',"\n",
  '<INPUT TYPE=hidden NAME="ofn" VALUE="',"$OFileName",'">',"\n",
  '<INPUT TYPE=hidden NAME="tf" VALUE="',"$TempFile",'">',"\n",
  '<INPUT TYPE=hidden NAME="fn" VALUE="',"$FileName",'">',"\n",
  '<INPUT TYPE=hidden NAME="ow" VALUE="',"$overwrite",'">',"\n",
  '<INPUT TYPE=hidden NAME="tm" VALUE="',"$textmode",'">',"\n",
  '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
  '<TR><TD ALIGN="center">',"\n",
  '<TABLE ',"$TableParam",'><TR><TD ALIGN="center">',"\n";
  if ($problem eq 'File Already Exists') {
    print '<INPUT TYPE=submit NAME="upcom" VALUE=" Overwrite Existing File ">',"\n",
    '</TD></TR><TR><TD ALIGN="center">',"\n";
  };
  print '<INPUT TYPE=submit NAME="upcom" VALUE="       Cancel Upload       ">',"\n",
  '</TD></TR></FORM>',"\n",
  '<FORM METHOD="',"$ReqMeth",'" ACTION="',"$ScriptUrl",'">',"\n",
  '<INPUT TYPE=hidden NAME="id" VALUE="',"$id",'">',"\n",
  '<INPUT TYPE=hidden NAME="pwd" VALUE="',"$pwd",'">',"\n",
  '<INPUT TYPE=hidden NAME="com" VALUE="',"$com",'">',"\n",
  '<INPUT TYPE=hidden NAME="ofn" VALUE="',"$OFileName",'">',"\n",
  '<INPUT TYPE=hidden NAME="tf" VALUE="',"$TempFile",'">',"\n",
  '<INPUT TYPE=hidden NAME="tm" VALUE="',"$textmode",'">',"\n",
  '<TR><TD ALIGN="center">',"\n",
  '<INPUT TYPE=submit  NAME="upcom" VALUE="Save Uploaded File As:">',"\n",
  '<INPUT SIZE="',"$FNFieldSize",'" NAME="fn" value="';
  unless ($problem eq 'No Filename') {print "$FileName";} else {print &FullPath($pwd,'');};
  print '">',"\n",
  '</TD></TR></TABLE></TD></TR></TABLE></FORM></CENTER><HR></BODY></HTML>',"\n";
  $done = 1;
}

sub PrintUpload { # Prints an upload form.

  print '<HTML><HEAD><TITLE> WebRSH - Upload Form </TITLE></HEAD>',"\n",
  '<BODY bgcolor="',"$BGColor\" $BodyParam",'><B> WebRSH: Upload Form: </B>',"\n";
#  if ($!) {print '<H2> The system reported an error: ',"$!",'</H2>',"\n";};
  unless ($output) {print '<P> Your command did not generate any output </P>',"\n";}
  else {
    &GetDirList(0);
    print '<P> The form below can be used to upload a file to your working directory',"\n",
    'on ',"$HostName",'. Clicking any of the "OPEN: [ * ]" links will send an upload',"\n",
    'form for the corresponding directory.',"\n",
    '</P><CENTER><H2><HR> Working Directory is: ',"$pwd\n",'</H2>',"\n",
    '<FORM METHOD="POST" ENCTYPE="multipart/form-data" ACTION="',"$ScriptUrl",'">',"\n",
    '<INPUT TYPE=hidden name="id" value="',"$id",'">',"\n",
    '<INPUT TYPE=hidden name="pwd" value="',"$pwd",'">',"\n",
    '<INPUT TYPE=hidden name="com" value="rshupload">',"\n",
    '<TABLE BGCOLOR="',"$TableColor\" $FTableParam",'>',"\n",
    '<TR><TD ALIGN="center">',"\n",
    '<TABLE ',"$TableParam",'><TR><TD ALIGN="center"><TABLE><TR><TD>',"\n",
    '<INPUT TYPE="checkbox" name="ow" value="1"> Overwrite Existing File </TD>',"\n",
    '<TD NOWRAP COLSPAN=8></TD><TD>',"\n",
    '<INPUT TYPE="checkbox" name="tm" value="1"> Text Mode </TD></TR></TABLE></TD></TR>',"\n",
    '<TR><TD ALIGN="center">FILE TO UPLOAD: <INPUT TYPE=file NAME=upfile SIZE="40"></TD></TR>',"\n",
    '<TR><TD ALIGN="center"><INPUT VALUE="        Upload        "  TYPE=submit> ',"\n",
    '</TD></TR></TABLE></TD></TR></TABLE></FORM></CENTER>',"\n",
    '<TABLE><TR><TD><B>',"\n",
    '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshuploadform+..">',"\n",
    '<IMG SRC="',"$SendFilesUrl",'/back.gif" ALIGN=left HSPACE=0 BORDER=0> OPEN:  [ .. ]</A></B></TD></TR>',"\n";
    foreach $i (0..$#dirarray) { 
      print '<TR><TD NOWRAP><B>',"\n",
      '<A HREF="',"$ScriptUrl",'?id=',"$id",'&pwd=',"$lpwd",'&com=rshuploadform+',"$ldirarray[$i]",'">',"\n",
      '<IMG SRC="',"$SendFilesUrl",'/menu.gif" ALIGN=left HSPACE=2 BORDER=0> OPEN:  [ ',"$dirarray[$i]",' ]</A></B></TD></TR>',"\n";
    }
    print '<TR><TD></TD></TR></TABLE>',"\n";
  }
}

1; # return true
